<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Software Versioning</title>

    <meta name="description" content="ESTP 2023 course, day 2: Software Versioning">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-markdown data-state="blue_overlay 9 yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/graph_-_5432 (Original).mp4" data-background-video-loop data-background-video-muted="true">
<!-- https://pixabay.com/videos/graph-income-profits-chart-5432/ -->
<textarea data-template>

# Software Versioning

<br>
<br>

<a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">
</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
<textarea data-template>

## Table of Contents!

- [Why versioning?](#/why)
- [CalVer](#/calver)
- [SemVer](#/semver)
- [Weird versioning](#/weird)
- [Summary](#/summary)
- [Links](#/links)

</textarea>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/recursion-icon-2865934.png" id="why">
<!-- https://pixabay.com/vectors/recursion-icon-iteration-icon-2865934/ -->
<textarea data-template>

# What is it good for?

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/recursion-icon-2865934.png">
<textarea data-template>
<!-- https://pixabay.com/vectors/recursion-icon-iteration-icon-2865934/ -->
## Which of these is the most recent version?

    script.py
    script.py.bak
    new_script.py
    script_final.py
    script_final_2.py
    script_submitted.py
    script_submitted_2.py

</textarea>
</section>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay 3" data-background="./files/question-mark-2492009_1920.jpg">
<!-- https://pixabay.com/illustrations/question-mark-pile-questions-symbol-2492009/ -->
<textarea data-template>

## Quiz
### Which versioning scheme have you (ab)used?

</textarea>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/note-5459693.svg" id="calver">
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->
<textarea data-template>

# CalVer
https://calver.org/

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/note-5459693.svg">
<textarea data-template>
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->

## Examples
- `2023.06.06`
- `Ubuntu 22.04`
- `Windows 95`
- `Fifa 2010`

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/note-5459693.svg">
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->
<textarea data-template>

## Terminology



<ul style="font-size: xx-large;">
  <li><code>YYYY</code> Full year - 2006, 2016, 2106</li>
  <li><code>YY</code> Short year - 6, 16, 106</li>
  <li><code>0Y</code> Zero-padded year - 06, 16, 106</li>
  <li><code>MM</code> Short month - 1, 2 ... 11, 12</li>
  <li><code>0M</code> Zero-padded month - 01, 02 ... 11, 12</li>
  <li><code>WW</code> Short week (since start of year) - 1, 2, 33, 52</li>
  <li><code>0W</code> Zero-padded week - 01, 02, 33, 52</li>
  <li><code>DD</code> Short day - 1, 2 ... 30, 31</li>
  <li><code>0D</code> Zero-padded day - 01, 02 ... 30, 31</li>
</ul>

<br>
<br>

<ul style="font-size: xx-large;">
  <li>Assumption: UTC, Gregorian calendar</li>
  <li>Recommended: American date format</li>
  <ul>
    <li>sorting alphabetically results in sorting chronologically</li>
  </ul>
</ul>

<footer><a href="https://calver.org">calver.org</a> under <a href="https://creativecommons.org/licenses/by-sa/4.0/">CC BY-SA 4.0</a></footer>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/note-5459693.svg">
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->
<textarea data-template>

## CalVer Pros

- "Freshness"
  - Version `2024.06` is rather recent
- No "Bigger is better", marketing
  - As in *Firefox vs Chrome*

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/note-5459693.svg">
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->
<textarea data-template>

## CalVer Cons

- "Maturity"
  - `0.2.0` &nbsp; vs &nbsp; `3.1.4`
- No indication of API breakage
  - Is my code compatible  with version `2016.10` &nbsp;?

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/note-5459693.svg">
<!-- https://pixabay.com/vectors/note-calendar-calculator-schedule-5459693/ -->
<textarea data-template>

## Projects using CalVer

- Apple Gadget from 2022 `YYYY`
- Cool Conference '22 `YY`
- Ubuntu 22.04 `YY.0M`
  - LTS versions supported for 5 years
- pip `YY.MINOR.MICRO`
- certifi `YYYY.MM.DD`
  - wrapper around Mozilla's certificate authority bundle

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg" id="semver">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

# SemVer
https://semver.org/


</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## Examples
- `10.102.370`
- `1.0.0-alpha.1`
- `1.0.0+20130313144700`
- `Web 2.0`
- `API v3`
  - But `v` is not part of the version

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## Terminology
`MAJOR.MINOR.PATCH`

- `MAJOR` backwards incompatible changes
  - `MAJOR=0` API may change _any time_ 
- `MINOR` added backwards incompatible functionality
- `PATCH` backwards compatible bugfixes
- `1.0.0` defines public API

<footer><a href="https://semver.org">semver.org</a> under <a href="https://creativecommons.org/licenses/by/3.0/">CC BY 3.0</a></footer>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## Optional Terminology
- May include pre-release identification
  - Considered unstable
  - `1.0.0-alpha.1`
- May include build metadata
  - `1.0.0+20130313144700`
- May include both
  - `1.0.0-alpha+001`

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

### Terminology Variant
- `MAJOR.MINOR.PATCH.BUILD`
- Not strictly SemVer, but still useful

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## SemVer Pros

- Widely used
- "Maturity"
  - `0.2.0` &nbsp; vs &nbsp; `3.1.4`
- Long-term-stable (LTS) versions 
  - Maintain older versions with fresh patches
- `1.0.0` as a milestone

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## Intermezzo: LTS examples

<div style="width: 49%; float: left;">
  <h3>SemVer</h3>
  <ul>
  <li>Co-existing kernel versions</li>
    <ul>
      <li><code>4.19.312</code></li>
      <li><code>5.4.276</code></li>
      <li><code>5.10.217</code></li>
      <li><code>5.15.159</code></li>
      <li><code>6.1.90</code></li>
      <li><code>6.6.31</code></li>
    </ul>
    <li>N.B. More patches for older versions</li>
  </ul>
</div>

<div style="width: 49%; float: right;">
  <h3>CalVer</h3>
  <ul>
  <li>Co-existing Ubuntu versions</li>
    <ul>
      <li><code>20.04.6 LTS</code></li>
      <li><code>22.04.4 LTS</code></li>
      <li><code>23.10</code></li>
      <li><code>24.04</code></li>
    </ul>
  <li>No patch information</li>
  <li>"Point releases" to fix CalVer shortcoming</li>
  </ul>
</div>
<footer>as of 2024.05.27</footer>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## SemVer Cons

- "Freshness"
  - How old is version `2.7.1` ?
- "Bigger is better", marketing
- Superstition `13, 14`
- `1.0.0` as a milestone

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/track-and-field-1867053_1920.jpg">
<!-- https://pixabay.com/photos/track-and-field-athletic-field-1867053/ -->
<textarea data-template>

## Projects using SemVer

- Almost all software
  - though not all follow SemVer strictly

</textarea>
</section>
</section>

<section data-markdown data-state="standard" data-background="./files/pi-1453836_1920.jpg" id="weird">
<!-- https://pixabay.com/illustrations/pi-board-blackboard-chalk-math-1453836/ -->
<textarea data-template>

## Weird versioning

- SUSE Linux
  - Started with version `4.2`, see "Hitchhiker's"
- TeX
  - v3.141592653 asymptotically approaches `π`
- SmartEiffel compiler
  - Starts from `-1.0`, counts upwards towards `0.0`
- Urbit personal server platform
  - "Kelvin" version: count down, freeze project at `0K`
- Python PEP 440
  - Semver, Calver, mixed, everything compatible

<br style="margin: .5em;">

<div class="fragment">
  <b>Just don't.</b> Be clear, not clever.
</div>

</textarea>
</section>

<section data-markdown data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->
<textarea data-template>

<div style="transform: rotate(-5deg); width: 72%; float: left; margin-left: 2vw;">
  <h2 style="padding: 0; margin: 0;">Summary</h2>
  <ul style="padding-top: 0; margin-top: 0;">
    <li>CalVer for projects where ...</li>
    <ul>
      <li>software age is important, because of</li>
        <ul>
          <li>certain security patches or</li>
          <li>support schedules</li>
        </ul>
      <li>compatibility is not an issue</li>
    </ul>
    <li>SemVer for projects where ...</li>
    <ul>
      <li>multiple versions should co-exist</li>
      <li>compatibility is important</li>
    </ul>
  </ul>
</div>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources
- https://calver.org
- https://semver.org
- https://datacadamia.com/code/version/scheme
- https://blog.inedo.com/python-best-practices-for-versioning-python-packages-in-the-enterprise

</textarea>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
